/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-05-23 17:46:09 UTC)
 * on 2013-05-30 at 01:59:59 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.storage.model;

/**
 * An access-control list.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Cloud Storage API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class BucketAccessControls extends com.google.api.client.json.GenericJson {

  /**
   * The list of items.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<BucketAccessControl> items;

  /**
   * The kind of item this is. For lists of bucket access control entries, this is always
   * storage#bucketAccessControls.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * The list of items.
   * @return value or {@code null} for none
   */
  public java.util.List<BucketAccessControl> getItems() {
    return items;
  }

  /**
   * The list of items.
   * @param items items or {@code null} for none
   */
  public BucketAccessControls setItems(java.util.List<BucketAccessControl> items) {
    this.items = items;
    return this;
  }

  /**
   * The kind of item this is. For lists of bucket access control entries, this is always
   * storage#bucketAccessControls.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * The kind of item this is. For lists of bucket access control entries, this is always
   * storage#bucketAccessControls.
   * @param kind kind or {@code null} for none
   */
  public BucketAccessControls setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  @Override
  public BucketAccessControls set(String fieldName, Object value) {
    return (BucketAccessControls) super.set(fieldName, value);
  }

  @Override
  public BucketAccessControls clone() {
    return (BucketAccessControls) super.clone();
  }

}
